Permalink
Fetching contributors…
Cannot retrieve contributors at this time
152 lines (149 sloc) 3.69 KB
name: nirum
version:
# CHECK: When the version is bumped, update the docs and README.md file as
# well. Check using `git grep -E '[0-9]+\.[0-9]+\.[0-9]+' '*.md'` command.
'0.5.0'
synopsis: ! >
IDL compiler and RPC/distributed object framework for
microservices
description: ! >
Nirum is an IDL compiler and RPC/distributed object
framework for microservices, built on top of the modern
Web server technologies such as RESTful HTTP and JSON.
You can find how the language looks like from source codes in
the examples/ directory.
See also README.md for more details.
category: Language
author: Nirum team
maintainer: Nirum team
copyright: (c) 2016–2018 Nirum team
license: GPL-3
homepage: https://nirum.org/
git: git://github.com/nirum-lang/nirum.git
bug-reports: https://github.com/nirum-lang/nirum/issues
extra-source-files:
- CHANGES.md
- README.md
default-extensions:
- OverloadedStrings
flags:
static:
description: Static link
manual: true
default: false
when:
- condition: os(darwin)
else:
ghc-options:
- -Werror
then:
ghc-options:
- -Werror
- -optP-Wno-nonportable-include-path
# The above option works around https://github.com/haskell/cabal/issues/4739
dependencies:
- base >=4.7 && <5
- blaze-html >=0.9.0.1 && <0.10
- bytestring
- containers >=0.5.6.2 && <0.6
- directory >=1.2.5 && <1.4
- email-validate >=2.0.0 && <3.0.0
- filepath >=1.4 && <1.5
- htoml >=1.0.0.0 && <1.1.0.0
- interpolatedstring-perl6 >=1.0.0 && <1.1.0
- megaparsec >=6.5 && <6.6
- mtl >=2.2.1 && <3
- parsec # only for dealing with htoml's ParserError
- pretty >=1.1.3 && <2
- semver >=0.3.0 && <1.0
- text >=0.9.1.0 && <1.3
- unordered-containers # only for dealing with htoml's data structures
library:
source-dirs: src
ghc-options:
- -Wall
- -fwarn-incomplete-uni-patterns
- -fprint-explicit-kinds
other-modules:
- Paths_nirum
dependencies:
- blaze-markup >=0.8.0.0 && <0.9
- cmark-gfm >=0.1.3 && <0.2
- fsnotify >=0.3.0.1 && <0.4.0.0
- heterocephalus >=1.0.5 && <1.1.0
- optparse-applicative >=0.14 && <0.15
- shakespeare >=2.0.12 && <2.1
- stm >=2.4.4.1
- template-haskell >=2.11 && <3
- uri >=0.1 && <1.0
executables:
nirum:
main: nirum.hs
source-dirs: app
dependencies:
- base
- nirum
when:
- condition: flag(static)
then:
when:
- condition: os(darwin) || os(windows)
then:
ghc-options:
- -Wall
- -fwarn-incomplete-uni-patterns
- -threaded
- -with-rtsopts=-N
# Static link
- -static
- -optc-Os
else:
ghc-options:
- -Wall
- -fwarn-incomplete-uni-patterns
- -threaded
- -with-rtsopts=-N
# Static link
- -static
- -optl-static
- -optl-pthread
- -optc-Os
- -fPIC
else:
ghc-options:
- -Wall
- -fwarn-incomplete-uni-patterns
- -threaded
- -with-rtsopts=-N
tests:
hlint:
main: lint.hs
dependencies:
- hlint >=2.1.7 && <2.2
spec:
main: Main.hs
source-dirs:
- test
ghc-options:
- -Wall
- -fno-warn-incomplete-uni-patterns
- -fno-warn-missing-signatures
- -Wno-missing-signatures
- -threaded
- -with-rtsopts=-N
dependencies: # omit version specifiers for shared dependencies to library
- hspec
- hspec-core
- hspec-meta
- hxt >=9.3.1.16 && <9.4.0.0
- nirum
- process >=1.1 && <2
- semigroups
- string-qq >=0.0.2 && <0.1.0
- temporary >=1.2 && <1.4
targets:
main: test-targets.hs
source-dirs: app
dependencies:
- turtle
stability: alpha